#include <EEPROM.h>
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
  #include <avr/power.h>
#endif
#define PIN            3
#define NUMPIXELS      42

Adafruit_NeoPixel DIY_Camera_Light = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

const int SwitchDetection=0;
const int RedCell=1;
const int GreenCell=2;
const int BlueCell=3;
int Red=0;
int Green=0;
int Blue=0;
int Brightness=50;
int updateLight=1;
char Data=' ';
void setup() 
{
  Serial.begin(9600);
  DIY_Camera_Light.begin(); // This initializes the NeoPixel library.
  DIY_Camera_Light.setBrightness(Brightness);
  switch(EEPROM.read(SwitchDetection))
  {
    case(0):
    {
      EEPROM.write(RedCell,255);
      EEPROM.write(GreenCell,100);
      EEPROM.write(BlueCell,10);
    }break;
    case(1):
    {
      EEPROM.write(RedCell,255);
      EEPROM.write(GreenCell,200);
      EEPROM.write(BlueCell,100);
    }break;
    case(2):
    {
      EEPROM.write(RedCell,255);
      EEPROM.write(GreenCell,120);
      EEPROM.write(BlueCell,50);
    }break;
  }
  EEPROM.write(SwitchDetection,EEPROM.read(SwitchDetection)+1);
  if(EEPROM.read(SwitchDetection)==3)
  EEPROM.write(SwitchDetection,0);
  Red=EEPROM.read(RedCell);
  Green=EEPROM.read(GreenCell);
  Blue=EEPROM.read(BlueCell);
}

void loop() 
{
  while(Serial.available())
  {
    Data=Serial.read();
    if(Data=='r')
    {
      updateLight=1;
      Red=Serial.parseInt();
      continue;
    }
    if(Data=='g')
    {
      Green=Serial.parseInt();
      continue;
    }
    if(Data=='b')
    {
      Blue=Serial.parseInt();
      continue;
    }
    if(Data=='c' || Data=='i')
    {
      for(int i=0; i<NUMPIXELS; i++)
      {
        DIY_Camera_Light.setPixelColor(i,0,0,0);
      }
      DIY_Camera_Light.show();
      delay(50);
      for(int i=0; i<NUMPIXELS; i++)
      {
        DIY_Camera_Light.setPixelColor(i,Red,Green,Blue);
      }
      DIY_Camera_Light.show();
      delay(50);
      for(int i=0; i<NUMPIXELS; i++)
      {
        DIY_Camera_Light.setPixelColor(i,0,0,0);
      }
      DIY_Camera_Light.show();
      delay(50);
      for(int i=0; i<NUMPIXELS; i++)
      {
        DIY_Camera_Light.setPixelColor(i,Red,Green,Blue);
      }
      DIY_Camera_Light.show();
      delay(50);
      continue;
    }
    if(Data=='A')
    {
      Brightness=Serial.parseInt();
      DIY_Camera_Light.setBrightness(Brightness);
      delay(2);
      DIY_Camera_Light.show();
    }
  }
  if(updateLight==1)
  {
    for(int i=0; i<NUMPIXELS; i++)
    {
      DIY_Camera_Light.setPixelColor(i,Red,Green,Blue);
    }
    DIY_Camera_Light.show();
    updateLight=0;
  }
}
